// Software developed by BenQ Mobile GmbH & Co. OHG for support of simulation framework within 3GPP SA4
//
// Waqar Zia (waqar.zia@benq.com) 30 May, 2006
//

#ifdef WIN32
#define _CRT_SECURE_NO_DEPRECATE
#endif

#include <stdio.h>
#include <stdlib.h>
#include "IsoFileClasses.hpp"
#include "ClassContainer.hpp"
#include "IsoBoxTypes.hpp"

using namespace ISOFile_Include_IsoFileClasses_hpp;
using namespace ISOFile_Include_ClassContainer_hpp;
using namespace ISOFile_Include_IsoBoxTypes_hpp;

void test()
{
   try 
    {
        const unsigned int rdSz = 5000;
        FILE *myReadFile = fopen("E:\\My Documents\\Softwares\\SA4\\Work\\SA4\\QT\\walk_friends_QCIF.3gp","rb");
        unsigned char decBuffer[rdSz];
        fread(decBuffer,1,rdSz,myReadFile);
        fclose(myReadFile);

        ClassContainer myDecClassContainer;
        BufferManager fileDecBufferManager;
        
        fileDecBufferManager.writeData((Byte *)decBuffer,rdSz);
        
        try
        {
            myDecClassContainer.decodeAll(&fileDecBufferManager);
        }
        catch(int)
        {
           ;
        }

        TimeToSampleBox *stts = (TimeToSampleBox *)myDecClassContainer.getBoxRecursive(IsoBoxTypes::type_TimeToSampleBox);
        TrackHeaderBox *trackHeader = (TrackHeaderBox *)myDecClassContainer.getBoxRecursive(IsoBoxTypes::type_TrackHeaderBox);
        MediaHeaderBox *mdhd = (MediaHeaderBox *)myDecClassContainer.getBoxRecursive(IsoBoxTypes::type_MediaHeaderBox);
        TimeToSampleBox *tts = (TimeToSampleBox *)myDecClassContainer.getBoxRecursive(IsoBoxTypes::type_TimeToSampleBox);
        SampleSizeBox *sampSz = (SampleSizeBox *)myDecClassContainer.getBoxRecursive(IsoBoxTypes::type_SampleSizeBox);
        ChunkOffsetBox *chOff = (ChunkOffsetBox *)myDecClassContainer.getBoxRecursive(IsoBoxTypes::type_ChunkOffsetBox);
        stts->decode_sample_delta();

        BufferManager fileEncBufferManager;
        unsigned char *encBuffer;
        unsigned int wrtSz;

        myDecClassContainer.encodeAll(&fileEncBufferManager);

        wrtSz = fileEncBufferManager.getBuffer(&encBuffer);

        FILE *myWriteFile = fopen("test.iso","wb");
        fwrite(encBuffer,1,wrtSz,myWriteFile);
        fclose(myWriteFile);

    }
    catch( char * str ) 
    {
        printf("Exception raised: %s\n",str);
    }
}

extern "C" {
void cInterface()
{
    test();
    return;
}
}


