// Software developed by BenQ Mobile GmbH & Co. OHG for support of simulation framework within 3GPP SA4
//
// Waqar Zia (waqar.zia@benq.com) 28 May, 2006
//

#ifndef _ISOFILE_INCLUDE_ISO_BOX_TYPES_HPP_
#define _ISOFILE_INCLUDE_ISO_BOX_TYPES_HPP_

#include "Namespace.hpp"

DECLARE_NAMESPACE(ISOFile_Include_IsoBoxTypes_hpp);

  /**
    *   Class IsoBoxTypes, the identification "keys" for various box types as given in ISO/IEC 14496-12:2005(E)
    *   
    */

class IsoBoxTypes
{
    public:
        static const char *type_FileTypeBox;
        static const char *type_MovieBox;
        static const char *type_MediaDataBox;
        static const char *type_FreeSpaceBox;
        static const char *type_MovieHeaderBox;
        static const char *type_TrackBox;
        static const char *type_TrackHeaderBox;
        static const char *type_MediaBox;
        static const char *type_MediaHeaderBox;
        static const char *type_HandlerBox;
        static const char *type_MediaInformationBox;
        static const char *type_VideoMediaHeaderBox;
        static const char *type_DataInformationBox;
        static const char *type_DataEntryUrlBox;
        static const char *type_DataEntryUrnBox;
        static const char *type_DataReferenceBox;
        static const char *type_SampleTableBox;
        static const char *type_TimeToSampleBox;
        static const char *type_CompositionOffsetBox;
        static const char *type_SampleDescriptionBox;
        static const char *type_SampleSizeBox;
        static const char *type_SampleToChunkBox;
        static const char *type_ChunkOffsetBox;
};

END_NAMESPACE(ISOFile_Include_IsoBoxTypes_hpp);

#endif //_ISOFILE_INCLUDE_ISO_BOX_TYPES_HPP_

